
-- smw luigi power up specific stuff

-- like uh powering up

freeslot("sfx_smwpwu", "sfx_smwpwd")

sfxinfo[sfx_smwpwu].caption = "Power up"
sfxinfo[sfx_smwpwd].caption = "Power down"

freeslot("S_SMW_GPUP")

states[S_SMW_GPUP] = {
    sprite = SPR_PLAY,
    frame = SPR2_SPIN,
    tics = 3,
    nextstate = S_SMW_GPUP
}

addHook("PlayerSpawn", function(p)
	if not (p.mo and p.mo.valid)
	or (p.mo.skin ~= "smwmario" and p.mo.skin ~= "smwluigi") return end
	
	if p.smwpowerup == 1
		p.mo.state = S_PLAY_WALK
	end
end)

addHook("PlayerThink", function(p)
	if not (p.mo and p.mo.valid)
	or (p.mo.skin ~= "smwmario" and p.mo.skin ~= "smwluigi") return end
	
	if p.smwpowerup == nil
		p.smwpowerup = 0
		p.smwlosepup = false
		p.smwgainpup = false
		p.smwpuptime = 0
	end
	
	if p.smwpowerup ~= 0
		p.mo.eflags = $1|MFE_FORCESUPER
	elseif (p.mo.eflags & MFE_FORCESUPER)
		p.mo.eflags = $ & ~MFE_FORCESUPER
	end
	
	if p.smwlosepup
		p.pflags = $1|PF_FULLSTASIS
		if p.smwpowerup == 2
			p.mo.color = p.skincolor
			p.powers[pw_shield] = $ & ~SH_FIREFLOWER
			p.smwpowerup = 1
		end
		p.mo.momx = 0
		p.mo.momy = 0
		p.mo.momz = 0
		p.powers[pw_flashing] = 2*TICRATE+TICRATE/2
		if p.mo.state ~= S_SMW_GPUP
			p.mo.state = S_SMW_GPUP
		end
		if p.smwpuptime > 0
			p.smwpuptime = $-FU
		else
			p.smwlosepup = false
			p.mo.momx = p.smwoldmom.x
			p.mo.momy = p.smwoldmom.y
			p.mo.momz = p.smwoldmom.z
			p.mo.state = p.smwoldstate
			P_MovePlayer(p)
			p.smwoldmom = nil
			p.smwoldstate = nil
			p.smwpowerup = 0
		end
	end
	
	if p.smwgainpup
		p.pflags = $1|PF_FULLSTASIS
		p.mo.momx = 0
		p.mo.momy = 0
		p.mo.momz = 0
		p.powers[pw_flashing] = TICRATE
		if p.mo.state ~= S_SMW_GPUP
			p.mo.state = S_SMW_GPUP
		end
		if p.smwpuptime > 0
			p.smwpuptime = $-FU
		else
			p.smwgainpup = false
			p.mo.momx = p.smwoldmom.x
			p.mo.momy = p.smwoldmom.y
			p.mo.momz = p.smwoldmom.z
			p.mo.state = p.smwoldstate
			P_MovePlayer(p)
			p.smwoldmom = nil
			p.smwoldstate = nil
			p.smwpowerup = $+1
		end
	end
	
	if p.powers[pw_shield]
		if (p.powers[pw_shield] & SH_FIREFLOWER)
			p.smwpowerup = 1
		end
		p.powers[pw_shield] = 0
		P_RemoveShield(p)
		S_StartSound(p.mo, sfx_smwpwu)
		p.smwoldmom = {
			x = p.mo.momx,
			y = p.mo.momy,
			z = p.mo.momz
		}
		--p.smwpuptime = (996*TICRATE)/(1000*TICRATE)
		p.smwpuptime = FixedDiv(996*FU, 1000*FU)*TICRATE
		p.smwoldstate = p.mo.state
		p.smwgainpup = true
	end
end)

addHook("MobjDamage", function(pmo, inf, src, _, dmg)
	if not (pmo and pmo.valid)
	or (pmo.skin ~= "smwmario" and pmo.skin ~= "smwluigi") return end
	
	if pmo.player.smwpowerup == 0
		P_KillMobj(pmo, inf, src, dmg)
	else
		pmo.player.powers[pw_shield] = $ & ~SH_FIREFLOWER
		S_StartSound(pmo, sfx_smwpwd)
		pmo.player.smwoldmom = {
			x = pmo.momx,
			y = pmo.momy,
			z = pmo.momz
		}
		pmo.player.smwoldstate = pmo.state
		--pmo.player.smwpuptime = (779*TICRATE*)/(1000*TICRATE)
		pmo.player.smwpuptime = FixedDiv(779*FU, 1000*FU)*TICRATE
		pmo.player.smwlosepup = true
		pmo.player.powers[pw_flashing] = 2*TICRATE
	end
	return true
end, MT_PLAYER)

addHook("MobjDeath", function(pmo)
	if not (pmo and pmo.valid)
	or (pmo.skin ~= "smwmario" and pmo.skin ~= "smwluigi") return end
	
	pmo.player.smwpowerup = 0
end, MT_PLAYER)

addHook("TouchSpecial", function(mo, pmo)
	if not (pmo and pmo.valid)
	or not (mo and mo.valid)
	or (pmo.skin ~= "smwmario" and pmo.skin ~= "smwluigi") return end
	
	if pmo.player.smwpowerup == 0
		pmo.player.smwpowerup = 1
	end
end, MT_STARPOST)