local function canCrouch(p)
	if not P_IsObjectOnGround(p.mo)
	or P_PlayerInPain(p)
	or p.playerstate == PST_DEAD
		return false
	end
	return true
end

addHook("PlayerThink", function(p)
	if not (p.mo and p.mo.valid)
	or p.mo.skin ~= "smwmario" return end
	
	if (p.cmd.buttons & BT_CUSTOM3)
	and canCrouch(p)
		p.smwcrouch = true
	elseif p.smwcrouch ~= false
		p.smwcrouch = false
	end
	
	if p.smwcrouch
        p.mo.state = S_PLAY_GLIDE_LANDING
		p.pflags = $1|PF_STASIS
		p.drawangle = p.mo.angle
		if p.speed > 5*FU
			P_SpawnSkidDust(p, 5*FU, 69420)
		end
	end
end)

addHook("PlayerHeight", function(p)
	if not (p.mo and p.mo.valid)
	or p.mo.skin ~= "smwmario" return end
	
	if p.smwcrouch return P_GetPlayerSpinHeight(p) end
end)

addHook("PlayerCanEnterSpinGaps", function(p)
	if not (p.mo and p.mo.valid)
	or p.mo.skin ~= "smwmario" return end
	
	if p.smwcrouch return true end
end)