
-- fire baoul stuf
-- hyay :D

freeslot("SPR_FBLL", "S_SMW_FIREBALL", "SPR_MWCT", "S_SMW_FIREDEAD", "sfx_smwfb", "sfx_smwstp", "sfx_smwbmp")

sfxinfo[sfx_smwfb].caption = "Fire"
sfxinfo[sfx_smwstp].caption = "Boot-stomp"
sfxinfo[sfx_smwbmp].caption = "Bumpity bump"

states[S_SMW_FIREBALL] = {
    sprite = SPR_FBLL,
    frame = A|FF_ANIMATE,
    tics = -1,
    nextstate = S_SMW_FIREBALL,
	var1 = D,
	var2 = 2
}

states[S_SMW_FIREDEAD] = {
    sprite = SPR_MWCT,
    frame = A|FF_ANIMATE,
    tics = (H+1)*2,
    nextstate = S_NULL,
	var1 = H,
	var2 = 2
}

addHook("PlayerThink", function(p)
	if not (p.mo and p.mo.valid)
	or (p.mo.skin ~= "smwmario" and p.mo.skin ~= "smwluigi") return end
	
	if p.smwfblimit == nil
		p.smwfblimit = 0
	end
	
	if (p.cmd.buttons & BT_SPIN)
		p.smwspheld = $+1
	else
		p.smwspheld = 0
	end
	
	/*if (p.cmd.buttons & BT_ATTACK)
		p.smwfheld = $+1
	else
		p.smwfheld = 0
	end
	
	if (p.cmd.buttons & BT_FIRENORMAL)
		p.smwfnheld = $+1
	else
		p.smwfnheld = 0
	end*/
	
	if p.smwpowerup == 2
		if not p.smwflowergot
			p.mo.color = SKINCOLOR_WHITE
			p.smwflowergot = true
		end
		
		--if (p.smwfheld == 1 or p.smwfnheld == 1)
		if p.smwspheld == 1
		--and not p.weapondelay
		and p.smwfblimit < 2
			--p.weapondelay = TICRATE
			p.mo.state = S_PLAY_FIRE
			--local fb = P_SPMAngle(p.mo, MT_SMW_FIREBALL, p.mo.angle, 0)
			local fb = P_SPMAngle(p.mo, MT_FIREBALL, p.mo.angle, 0)
				S_StartSound(p.mo, sfx_smwfb)
			if (fb and fb.valid)
				fb.state = S_SMW_FIREBALL
				fb.spritexscale = FU*2
				fb.spriteyscale = FU*2
				p.smwfblimit = $+1
			end
		end
		
		if p.smwspinjump
		and p.smwfblimit < 2
			p.smwfbangle = $+FixedAngle(90*FU/2)
			local fb = P_SPMAngle(p.mo, MT_FIREBALL, p.smwfbangle, 0)
			S_StartSound(p.mo, sfx_smwfb)
			if (fb and fb.valid)
				fb.state = S_SMW_FIREBALL
				fb.spritexscale = FU*2
				fb.spriteyscale = FU*2
				p.smwfblimit = $+1
			end
		elseif not p.smwspinjump
			p.smwfbangle = p.drawangle
		end
	elseif p.smwflowergot ~= false
		p.smwflowergot = false
	end
end)

addHook("MobjMoveBlocked", function(mo)
	if not (mo.target and mo.target.valid)
	or (mo.target.skin ~= "smwmario" and mo.target.skin ~= "smwluigi") return end
	
	P_KillMobj(mo)
end, MT_FIREBALL)

addHook("MobjDeath", function(mo, inf)
	if not (mo.target and mo.target.valid)
	or (mo.target.skin ~= "smwmario" and mo.target.skin ~= "smwluigi") return end
	
	local p = mo.target.player
	
	p.smwfblimit = $-1
	local fx = P_SpawnMobj(mo.x, mo.y, mo.z, MT_GFZTREE)
	fx.state = S_SMW_FIREDEAD
	fx.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
	fx.spritexscale = mo.spritexscale
	fx.spriteyscale = mo.spriteyscale
	
	if (inf and inf.valid)
	and (inf.flags & MF_SHOOTABLE) return end
	
	S_StartSound(fx, sfx_smwbmp)
end, MT_FIREBALL)

addHook("MobjDeath", function(mo, fb)
	if not (mo.flags & MF_ENEMY)
	or not (fb and fb.valid)
	or fb.type ~= MT_FIREBALL
	or not (fb.target and fb.target.valid)
	or (fb.target.skin ~= "smwmario" and fb.target.skin ~= "smwluigi") return end
	
	S_StartSound(mo, sfx_smwstp)
	fb.target.player.smwnosfxmobj = mo
	local r = P_SpawnMobj(mo.x, mo.y, mo.z+mo.height, MT_FLINGRING)
	r.angle = fb.angle
	P_InstaThrust(r, r.angle, 7*FU)
	P_SetObjectMomZ(r, 5*FU)
	r.flags = $1|MF_BOUNCE
end)